diff a/src/hotspot/share/runtime/perfData.cpp b/src/hotspot/share/runtime/perfData.cpp
--- a/src/hotspot/share/runtime/perfData.cpp
+++ b/src/hotspot/share/runtime/perfData.cpp
@@ -525,5 +525,12 @@
   assert(copy != nullptr, "just checking");
 
   return copy;
 }
 
+PerfTraceTimeBase::~PerfTraceTimeBase() {
+  if (!UsePerfData || !_t->is_active()) return;
+  if (_counter != nullptr) {
+    _t->stop();
+    _counter->inc(_t->ticks());
+  }
+}
